import { EventEmitter, ChangeDetectorRef, OnDestroy, AfterViewInit, ElementRef, OnInit } from '@angular/core';
import { FormControl, NgForm, FormGroup } from '@angular/forms';
import { SdCurrencyPipe } from '@sd-angular/core/utility';
export declare class SdInput implements OnDestroy, OnInit, AfterViewInit {
    #private;
    private ref;
    private currencyPipe;
    size: 'sm' | 'lg';
    set form(val: NgForm | FormGroup);
    label: string;
    placeholder: string;
    type: 'text' | 'number' | 'password' | 'email';
    step: number;
    leftLabel: string;
    labelMinWidth: string;
    set model(value: any);
    modelChange: EventEmitter<any>;
    isRequired: boolean;
    set required(val: boolean | '');
    minlength: number;
    set pMinlength(val: number);
    maxlength: number;
    set pMaxlength(val: number);
    set pattern(val: string);
    set validator(validator: (value: any) => string | Promise<string>);
    set disabled(val: boolean | '');
    icon: string;
    tooltip: string | ((inputValue: string) => string);
    sdClick: EventEmitter<any>;
    sdChange: EventEmitter<any>;
    sdFocus: EventEmitter<any>;
    sdFocusForceBlur: EventEmitter<any>;
    keyupEnter: EventEmitter<any>;
    control: ElementRef;
    formControl: FormControl;
    constructor(ref: ChangeDetectorRef, currencyPipe: SdCurrencyPipe);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    reValidate: () => void;
    onKeyupEnter: () => void;
    onClick: () => void;
    onFocus: () => void;
    onBlur: () => void;
    blur: () => void;
}
